#include <stdio.h>
#include <ctype.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "port.h"
#include <unistd.h>

//long lseek(int,long,int);

long getfilelen(int fd)
{ 
	long reslt,curr;
	curr = lseek(fd,0,SEEK_CUR);
	reslt = lseek(fd,0,SEEK_END);
	lseek(fd,curr,SEEK_SET);
	return reslt;
}



#ifdef _UNIX_

char* strupr(char* s)
{
  char* p = s;
  while (*p = toupper(*p)) p++;
  return s;
}

char* strlwr(char* s)
{
  char* p = s;
  while (*p = tolower(*p)) p++;
  return s;
}

int strnicmp(const char* s1, const char* s2, int len)
{
  unsigned char c1,c2;
  
  if(!len)
	return 0;
  
  do{
    c1 = *s1++;
    c2 = *s2++;
    if (!c1||!c2)
      break;
    if (c1 == c2)
      continue;
    c1 = tolower(c1);
    c2 = tolower(c2);
    if (c1!=c2)
      break;
  } while (--len);
  return (int)c1 - (int)c2;
}


#endif //_UNIX_
